/**
 * WebMidi.js v3.0.0-alpha.8
 * A JavaScript library to kickstart your MIDI projects
 * https://webmidijs.org
 *
 * This build was generated on September 13th 2021.
 *
 *
 *
 * The MIT License (MIT)
 *
 * Copyright (c) 2015-2020, Jean-Philippe Côté
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"), to deal in the Software without restriction,
 * including without limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT
 * NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

class e{constructor(e=!1){this.eventMap={},this.eventsSuspended=1==e}addListener(n,a,r={}){if("string"==typeof n&&n.length<1||n instanceof String&&n.length<1||"string"!=typeof n&&!(n instanceof String)&&n!==e.ANY_EVENT)throw new TypeError("The 'event' parameter must be a string or EventEmitter.ANY_EVENT.");if("function"!=typeof a)throw new TypeError("The callback must be a function.");const s=new t(n,this,a,r);return this.eventMap[n]||(this.eventMap[n]=[]),r.prepend?this.eventMap[n].unshift(s):this.eventMap[n].push(s),s}addOneTimeListener(e,t,n={}){n.remaining=1,this.addListener(e,t,n)}static get ANY_EVENT(){return Symbol.for("Any event")}hasListener(n,a){return void 0===n?!!(this.eventMap[e.ANY_EVENT]&&this.eventMap[e.ANY_EVENT].length>0)||Object.entries(this.eventMap).some(([,e])=>e.length>0):!!(this.eventMap[n]&&this.eventMap[n].length>0)&&(a instanceof t?this.eventMap[n].filter(e=>e===a).length>0:"function"==typeof a?this.eventMap[n].filter(e=>e.callback===a).length>0:null==a)}get eventNames(){return Object.keys(this.eventMap)}getListeners(e){return this.eventMap[e]||[]}suspendEvent(e){this.getListeners(e).forEach(e=>{e.suspended=!0})}unsuspendEvent(e){this.getListeners(e).forEach(e=>{e.suspended=!1})}getListenerCount(e){return this.getListeners(e).length}emit(t,...n){if("string"!=typeof t&&!(t instanceof String))throw new TypeError("The 'event' parameter must be a string.");if(this.eventsSuspended)return;let a=[],r=this.eventMap[e.ANY_EVENT]||[];return this.eventMap[t]&&(r=r.concat(this.eventMap[t])),r.forEach(e=>{if(e.suspended)return;let t=[...n];Array.isArray(e.arguments)&&(t=t.concat(e.arguments)),e.remaining>0&&(a.push(e.callback.apply(e.context,t)),e.count++),--e.remaining<1&&e.remove()}),a}removeListener(e,t,n={}){if(void 0===e)return void(this.eventMap={});if(!this.eventMap[e])return;let a=this.eventMap[e].filter(e=>t&&e.callback!==t||n.remaining&&n.remaining!==e.remaining||n.context&&n.context!==e.context);a.length?this.eventMap[e]=a:delete this.eventMap[e]}async waitFor(e,t={}){return t.duration=parseInt(t.duration),(isNaN(t.duration)||t.duration<=0)&&(t.duration=1/0),new Promise((n,a)=>{let r,s=this.addListener(e,()=>{clearTimeout(r),n()},{remaining:1});t.duration!==1/0&&(r=setTimeout(()=>{s.remove(),a("The duration expired before the event was emitted.")},t.duration))})}get eventCount(){return Object.keys(this.eventMap).length}}class t{constructor(t,n,a,r={}){if("string"!=typeof t&&!(t instanceof String)&&t!==e.ANY_EVENT)throw new TypeError("The 'event' parameter must be a string or EventEmitter.ANY_EVENT.");if(!n)throw new ReferenceError("The 'target' parameter is mandatory.");if("function"!=typeof a)throw new TypeError("The 'callback' must be a function.");void 0===r.arguments||Array.isArray(r.arguments)||(r.arguments=[r.arguments]),(r=Object.assign({context:n,remaining:1/0,arguments:void 0,duration:1/0},r)).duration!==1/0&&setTimeout(()=>this.remove(),r.duration),this.event=t,this.target=n,this.callback=a,this.context=r.context,this.remaining=parseInt(r.remaining)>=1?parseInt(r.remaining):1/0,this.count=0,this.arguments=r.arguments,this.suspended=!1}remove(){this.target.removeListener(this.event,this.callback,{context:this.context,remaining:this.remaining})}}const n=new class{getNoteNumberByName(e,t=0){if(t=parseInt(t),isNaN(t))return!1;"string"!=typeof e&&(e="");const n=this.getNoteFragments(e);if(console.info(n),!n)return!1;let a=12*(n.octave+1+t);return a+={C:0,D:2,E:4,F:5,G:7,A:9,B:11}[n.letter],n.accidental.startsWith("b")?a-=n.accidental.length:a+=n.accidental.length,!(a<0||a>127)&&a}getNoteFragments(e){const t=e.match(/^([CDEFGAB])(#{0,2}|b{0,2})(-?\d+)$/i);return!!t&&(console.log(t),{letter:t[1].toUpperCase(),accidental:t[2].toLowerCase(),octave:parseInt(t[3])})}sanitizeChannels(e){let t;if(this.validation)if("all"===e)t=["all"];else if("none"===e)return[];return t=Array.isArray(e)?e:[e],t.indexOf("all")>-1&&(t=[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16]),t.map((function(e){return parseInt(e)})).filter((function(e){return e>=1&&e<=16}))}convertToTimestamp(e){let t=!1,n=parseFloat(e);return!isNaN(n)&&("string"==typeof e&&"+"===e.substring(0,1)?n>=0&&(t=this.time+n):n>=0&&(t=n),t)}guessNoteNumber(e,t={}){null==t.octaveOffset&&(t.octaveOffset=0),t.octaveOffset=parseInt(t.octaveOffset);let n=!1;return Number.isInteger(e)&&e>=0&&e<=127||parseInt(e)>=0&&parseInt(e)<=127?n=parseInt(e):("string"==typeof e||e instanceof String)&&(n=this.getNoteNumberByName(e,{octaveOffset:this.octaveOffset})),!1!==n&&n}getNoteObject(e,t={}){if(null==t.octaveOffset&&(t.octaveOffset=0),e instanceof a)return e;{let n=this.guessNoteNumber(e,{octaveOffset:t.octaveOffset});if(!1!==n)return new a(n,t);throw new TypeError(`The input could not be parsed as a note (${e})`)}}getValidNoteArray(e,t={}){let n=[];return Array.isArray(e)||(e=[e]),e.forEach(e=>{n.push(this.getNoteObject(e,t))}),n}getNoteNameByNumber(e,t){if(WebMidi.validation){if(e=parseInt(e),isNaN(e)||e<0||e>127)throw new Error("Invalid note number");if(t=parseInt(t),isNaN(t))throw new Error("Invalid octaveOffset value")}const n=Math.floor(e/12-1)+t;return WebMidi.NOTES[e%12]+n.toString()}};n.constructor=null;class a{constructor(e,t={}){const a=null==t.octaveOffset?0:t.octaveOffset;if(this.duration=null==t.duration?1/0:t.duration,this.attack=null==t.attack?.5:t.attack,this.release=null==t.release?.5:t.release,Number.isInteger(e))this.name=n.getNoteNameByNumber(e,a);else{let t=name.match(/([CDEFGAB])(#{0,2}|b{0,2})(-?\d+)/i);if(!t)return!1;t[1].toUpperCase(),parseInt(t[3]);this.name=e}null!=t.rawAttack&&(this.rawAttack=t.rawAttack),null!=t.rawRelease&&(this.rawRelease=t.rawRelease)}getNumber(e=0){return n.getNoteNumberByName(this.name,e)}get attack(){return this._rawAttack/127}set attack(e){if(l.validation&&(e=parseFloat(e),isNaN(e)||null===e||!(e>=0&&e<=1)))throw new RangeError("Invalid attack value.");this._rawAttack=Math.round(127*e)}get duration(){return this._duration}set duration(e){if(l.validation&&(e=parseFloat(e),isNaN(e)||null===e||e<0))throw new RangeError("Invalid duration.");this._duration=e}get rawAttack(){return this._rawAttack}set rawAttack(e){if(l.validation&&(e=parseFloat(e),isNaN(e)||null===e||!(e>=0&&e<=127)))throw new RangeError("Invalid rawAttack value.");this._rawAttack=e}get release(){return this._rawRelease/127}set release(e){if(l.validation&&(e=parseFloat(e),isNaN(e)||null===e||!(e>=0&&e<=1)))throw new RangeError("Invalid release value.");this._rawRelease=Math.round(127*e)}get rawRelease(){return this._rawRelease}set rawRelease(e){if(l.validation&&(e=parseFloat(e),isNaN(e)||null===e||!(e>=0&&e<=127)))throw new RangeError("Invalid rawRelease value.");this._rawRelease=e}}class r extends e{constructor(e,t){super(),this.input=e,this.number=t,this._forwardTo=void 0,this._octaveOffset=0}destroy(){this.input=null,this.number=null,this.removeListener()}_parseEvent(e){let t=null;e.data[0]!==l.MIDI_SYSTEM_MESSAGES.sysex&&(t=e.data.slice(1));let n={target:this,data:Array.from(e.data),rawData:e.data,statusByte:e.data[0],dataBytes:t,timestamp:e.timeStamp,type:"midimessage"};this.emit("midimessage",n),this._parseEventForStandardMessages(e)}getStructuredMidiMessage(e){return{command:e[0]>>4,data1:e.length>1?e[1]:void 0,data2:e.length>2?e[2]:void 0}}_parseEventForStandardMessages(e){let{command:t,data1:n,data2:r}=this.getStructuredMidiMessage(e.data),s={target:this,data:Array.from(e.data),rawData:e.data,timestamp:e.timeStamp};t===l.MIDI_CHANNEL_VOICE_MESSAGES.noteoff||t===l.MIDI_CHANNEL_VOICE_MESSAGES.noteon&&0===r?(s.type="noteoff",s.note=new a(n,{rawRelease:r,octaveOffset:this.octaveOffset+this.input.octaveOffset+l.octaveOffset}),s.release=s.note.release,s.rawRelease=s.note.rawRelease):t===l.MIDI_CHANNEL_VOICE_MESSAGES.noteon?(s.type="noteon",s.note=new a(n,{rawAttack:r,octaveOffset:this.octaveOffset+this.input.octaveOffset+l.octaveOffset}),s.attack=s.note.attack,s.rawAttack=s.note.rawAttack):t===l.MIDI_CHANNEL_VOICE_MESSAGES.keyaftertouch?(s.type="keyaftertouch",s.note=new a(n,{octaveOffset:this.octaveOffset+this.input.octaveOffset+l.octaveOffset}),s.value=r/127,s.rawValue=r):t===l.MIDI_CHANNEL_VOICE_MESSAGES.controlchange&&n>=0&&n<=119?(s.type="controlchange",s.controller={number:n,name:this.getCcNameByNumber(n)},s.value=r/127,s.rawValue=r):t===l.MIDI_CHANNEL_VOICE_MESSAGES.channelmode&&n>=120&&n<=127?(s.type="channelmode",s.controller={number:n,name:this.getChannelModeByNumber(n)},s.value=r,this._parseChannelModeMessage(e)):t===l.MIDI_CHANNEL_VOICE_MESSAGES.programchange?(s.type="programchange",s.value=n+1,s.rawValue=n):t===l.MIDI_CHANNEL_VOICE_MESSAGES.channelaftertouch?(s.type="channelaftertouch",s.value=n/127,s.rawValue=n):t===l.MIDI_CHANNEL_VOICE_MESSAGES.pitchbend?(s.type="pitchbend",s.value=((r<<7)+n-8192)/8192,s.rawValue=(r<<7)+n):s.type="unknownmessage",this.emit(s.type,s)}getChannelModeByNumber(e){if(l.validation&&(e=Math.floor(e)),!(e>=120&&e<=127))return!1;for(let t in l.MIDI_CHANNEL_MODE_MESSAGES)if(l.MIDI_CHANNEL_MODE_MESSAGES.hasOwnProperty(t)&&e===l.MIDI_CHANNEL_MODE_MESSAGES[t])return t;return!1}_parseChannelModeMessage(e){let t,n;e.data.length>1&&(t=e.data[1],n=e.data.length>2?e.data[2]:void 0);let a={target:this,data:Array.from(e.data),rawData:e.data,timestamp:e.timeStamp,type:this.getChannelModeByNumber(t)};"localcontrol"===a.type&&(a.value=127===n),"omnimodeon"===a.type?(a.type="omnimode",a.value=!0):"omnimodeoff"===a.type&&(a.type="omnimode",a.value=!1),"monomodeon"===a.type?(a.type="monomode",a.value=!0):"polymodeon"===a.type&&(a.type="monomode",a.value=!1),this.emit(a.type,a)}getCcNameByNumber(e){if(l.validation&&!((e=parseInt(e))>=0&&e<=119))throw new RangeError("Invalid control change number.");for(let t in l.MIDI_CONTROL_CHANGE_MESSAGES)if(l.MIDI_CONTROL_CHANGE_MESSAGES.hasOwnProperty(t)&&e===l.MIDI_CONTROL_CHANGE_MESSAGES[t])return t;return!1}get octaveOffset(){return this._octaveOffset}set octaveOffset(e){if(this.validation&&(e=parseInt(e),isNaN(e)))throw new TypeError("The 'octaveOffset' property must be an integer.");this._octaveOffset=e}}class s extends e{constructor(e){super(),this._midiInput=e,this._octaveOffset=0,this.channels=[];for(let e=1;e<=16;e++)this.channels[e]=new r(this,e);this._midiInput.onstatechange=this._onStateChange.bind(this),this._midiInput.onmidimessage=this._onMidiMessage.bind(this)}async destroy(){this.removeListener(),this.channels.forEach(e=>e.destroy()),this.channels=[],this._midiInput.onstatechange=null,this._midiInput.onmidimessage=null,await this.close(),this._midiInput=null}_onStateChange(e){let t={timestamp:l.time,target:this};"open"===e.port.connection?(t.type="opened",this.emit("opened",t)):"closed"===e.port.connection&&"connected"===e.port.state?(t.type="closed",this.emit("closed",t)):"closed"===e.port.connection&&"disconnected"===e.port.state?(t.type="disconnected",t.target={connection:e.port.connection,id:e.port.id,manufacturer:e.port.manufacturer,name:e.port.name,state:e.port.state,type:e.port.type},this.emit("disconnected",t)):"pending"===e.port.connection&&"disconnected"===e.port.state||console.warn("This statechange event was not caught: ",e.port.connection,e.port.state)}_onMidiMessage(e){let t=null;e.data[0]!==l.MIDI_SYSTEM_MESSAGES.sysex&&(t=e.data.slice(1));let n={target:this,data:Array.from(e.data),rawData:e.data,statusByte:e.data[0],dataBytes:t,timestamp:e.timeStamp,type:"midimessage"};if(this.emit("midimessage",n),e.data[0]<240){let t=1+(15&e.data[0]);this.channels[t]._parseEvent(e)}else e.data[0]<=255&&this._parseEvent(e)}_parseEvent(e){let t=e.data[0];var n={target:this,data:Array.from(e.data),rawData:e.data,timestamp:e.timeStamp};t===l.MIDI_SYSTEM_MESSAGES.sysex?n.type="sysex":t===l.MIDI_SYSTEM_MESSAGES.timecode?n.type="timecode":t===l.MIDI_SYSTEM_MESSAGES.songposition?n.type="songposition":t===l.MIDI_SYSTEM_MESSAGES.songselect?(n.type="songselect",n.song=e.data[1]+1):t===l.MIDI_SYSTEM_MESSAGES.tunerequest?n.type="tunerequest":t===l.MIDI_SYSTEM_MESSAGES.clock?n.type="clock":t===l.MIDI_SYSTEM_MESSAGES.start?n.type="start":t===l.MIDI_SYSTEM_MESSAGES.continue?n.type="continue":t===l.MIDI_SYSTEM_MESSAGES.stop?n.type="stop":t===l.MIDI_SYSTEM_MESSAGES.activesensing?n.type="activesensing":t===l.MIDI_SYSTEM_MESSAGES.reset?n.type="reset":n.type="unknownmidimessage",this.emit(n.type,n)}async open(){try{return await this._midiInput.open(),Promise.resolve(this)}catch(e){return Promise.reject(e)}}async close(){return this._midiInput?this._midiInput.close():Promise.resolve()}getChannelModeByNumber(){l.validation&&console.warn("The 'getChannelModeByNumber()' method has been moved to the 'InputChannel' class.")}addListener(e,t,a={}){if(l.validation){if("function"==typeof a){let e=null!=t?[].concat(t):void 0;t=a,a={channels:e}}if(void 0!==l.MIDI_CHANNEL_VOICE_MESSAGES[e]&&void 0===a.channels)throw new Error("For channel-specific events, 'options.channels' must be defined.")}let r=[];return void 0===l.MIDI_CHANNEL_VOICE_MESSAGES[e]?r.push(super.addListener(e,t,a)):n.sanitizeChannels(a.channels).forEach(n=>{r.push(this.channels[n].addListener(e,t,a))}),r}addOneTimeListener(e,t,n={}){return n.remaining=1,this.addListener(e,t,n)}on(e,t,n,a){return this.addListener(e,t,n,a)}hasListener(e,t,a={}){if(l.validation){if("function"==typeof a){let e=[].concat(t);t=a,a={channels:e}}if(void 0!==l.MIDI_CHANNEL_VOICE_MESSAGES[e]&&void 0===a.channels)throw new Error("For channel-specific events, 'options.channels' must be defined.")}return void 0!==l.MIDI_CHANNEL_VOICE_MESSAGES[e]?n.sanitizeChannels(a.channels).every(n=>this.channels[n].hasListener(e,t)):super.hasListener(e,t)}removeListener(e,t,a={}){if(l.validation&&"function"==typeof a){let e=[].concat(t);t=a,a={channels:e}}if(void 0===a.channels&&(a.channels=[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16]),null==e)return n.sanitizeChannels(a.channels).forEach(e=>this.channels[e].removeListener()),super.removeListener();void 0!==l.MIDI_CHANNEL_VOICE_MESSAGES[e]?n.sanitizeChannels(a.channels).forEach(n=>{this.channels[n].removeListener(e,t,a)}):super.removeListener(e,t,a)}get name(){return this._midiInput.name}get id(){return this._midiInput.id}get connection(){return this._midiInput.connection}get manufacturer(){return this._midiInput.manufacturer}get octaveOffset(){return this._octaveOffset}set octaveOffset(e){if(this.validation&&(e=parseInt(e),isNaN(e)))throw new TypeError("The 'octaveOffset' property must be an integer.");this._octaveOffset=e}get state(){return this._midiInput.state}get type(){return this._midiInput.type}get nrpnEventsEnabled(){return l.validation&&console.warn("The 'nrpnEventsEnabled' property has been moved to the 'InputChannel' class."),!1}}class i extends e{constructor(e,t){super(),this.output=e,this.number=t}destroy(){this.output=null,this.number=null,this.removeListener()}send(e,t={time:0}){return this.output.send(e,t),this}setKeyAftertouch(e,t,a={}){if(l.validation){if(a.useRawValue&&(a.rawValue=a.useRawValue),isNaN(parseFloat(t)))throw new RangeError("Invalid key aftertouch value.");if(a.rawValue){if(!(t>=0&&t<=127&&Number.isInteger(t)))throw new RangeError("Key aftertouch raw value must be an integer between 0 and 127.")}else if(!(t>=0&&t<=1))throw new RangeError("Key aftertouch value must be a float between 0 and 1.")}return a.rawValue||(t=Math.round(127*t)),a.octaveOffset=l.octaveOffset,n.getValidNoteArray(e,a).forEach(e=>{this.send([(l.MIDI_CHANNEL_VOICE_MESSAGES.keyaftertouch<<4)+(this.number-1),e.number,t],{time:n.convertToTimestamp(a.time)})}),this}sendControlChange(e,t,a={}){if("string"==typeof e&&(e=l.MIDI_CONTROL_CHANGE_MESSAGES[e]),l.validation){if(void 0===e)throw new TypeError("Control change must be identified with a valid name or an integer between 0 and 119.");if(!Number.isInteger(e)||!(e>=0&&e<=119))throw new TypeError("Control change number must be an integer between 0 and 119.");if(!Number.isInteger(t)||!(t>=0&&t<=127))throw new TypeError("Control change value must be an integer between 0 and 127")}return this.send([(l.MIDI_CHANNEL_VOICE_MESSAGES.controlchange<<4)+(this.number-1),e,t],{time:n.convertToTimestamp(a.time)}),this}_selectNonRegisteredParameter(e,t={}){return this.sendControlChange(99,e[0],t),this.sendControlChange(98,e[1],t),this}_deselectRegisteredParameter(e={}){return this.sendControlChange(101,127,e),this.sendControlChange(100,127,e),this}_deselectNonRegisteredParameter(e={}){return this.sendControlChange(101,127,e),this.sendControlChange(100,127,e),this}_selectRegisteredParameter(e,t={}){return this.sendControlChange(101,e[0],t),this.sendControlChange(100,e[1],t),this}_setCurrentParameter(e,t={}){return e=[].concat(e),this.sendControlChange(6,e[0],t),e.length<2||this.sendControlChange(38,e[1],t),this}decrementRegisteredParameter(e,t={}){if(Array.isArray(e)||(e=l.MIDI_REGISTERED_PARAMETER[e]),l.validation){if(void 0===e)throw new TypeError("The specified registered parameter is invalid.");let t=!1;if(Object.getOwnPropertyNames(l.MIDI_REGISTERED_PARAMETER).forEach(n=>{l.MIDI_REGISTERED_PARAMETER[n][0]===e[0]&&l.MIDI_REGISTERED_PARAMETER[n][1]===e[1]&&(t=!0)}),!t)throw new TypeError("The specified registered parameter is invalid.")}return this._selectRegisteredParameter(e,t),this.sendControlChange(97,0,t),this._deselectRegisteredParameter(t),this}incrementRegisteredParameter(e,t={}){if(Array.isArray(e)||(e=l.MIDI_REGISTERED_PARAMETER[e]),l.validation){if(void 0===e)throw new TypeError("The specified registered parameter is invalid.");let t=!1;if(Object.getOwnPropertyNames(l.MIDI_REGISTERED_PARAMETER).forEach(n=>{l.MIDI_REGISTERED_PARAMETER[n][0]===e[0]&&l.MIDI_REGISTERED_PARAMETER[n][1]===e[1]&&(t=!0)}),!t)throw new TypeError("The specified registered parameter is invalid.")}return this._selectRegisteredParameter(e,t),this.sendControlChange(96,0,t),this._deselectRegisteredParameter(t),this}playNote(e,t={}){if(this.sendNoteOn(e,t),t.duration>0&&isFinite(String(t.duration).trim()||NaN)){let a={time:(n.convertToTimestamp(t.time)||l.time)+t.duration,release:t.release,rawRelease:t.rawRelease};this.sendNoteOff(e,a)}return this}sendNoteOff(e,t={}){if(l.validation){if(null!=t.rawRelease&&!(t.rawRelease>=0&&t.rawRelease<=127))throw new RangeError("The 'rawRelease' option must be an integer between 0 and 127");if(null!=t.release&&!(t.release>=0&&t.release<=1))throw new RangeError("The 'release' option must be an number between 0 and 1");t.rawVelocity&&(t.rawRelease=t.velocity,console.warn("The 'rawVelocity' option is deprecated. Use 'rawRelease' instead.")),t.velocity&&(t.release=t.velocity,console.warn("The 'velocity' option is deprecated. Use 'attack' instead."))}let a=64;null!=t.rawRelease?a=t.rawRelease:isNaN(t.release)||(a=Math.round(127*t.release));let r={rawRelease:parseInt(a)};return r.octaveOffset=l.octaveOffset,n.getValidNoteArray(e,r).forEach(e=>{this.send([(l.MIDI_CHANNEL_VOICE_MESSAGES.noteoff<<4)+(this.number-1),e.number,e.rawRelease],{time:n.convertToTimestamp(t.time)})}),this}stopNote(e,t={}){return this.sendNoteOff(e,t)}sendNoteOn(e,t={}){if(l.validation){if(null!=t.rawAttack&&!(t.rawAttack>=0&&t.rawAttack<=127))throw new RangeError("The 'rawAttack' option must be an integer between 0 and 127");if(null!=t.attack&&!(t.attack>=0&&t.attack<=1))throw new RangeError("The 'attack' option must be an number between 0 and 1");t.rawVelocity&&(t.rawAttack=t.velocity,t.rawRelease=t.release,console.warn("The 'rawVelocity' option is deprecated. Use 'rawAttack' or 'rawRelease'.")),t.velocity&&(t.attack=t.velocity,console.warn("The 'velocity' option is deprecated. Use 'attack' instead."))}let a=64;null!=t.rawAttack?a=t.rawAttack:isNaN(t.attack)||(a=Math.round(127*t.attack));let r={rawAttack:a};return r.octaveOffset=l.octaveOffset,n.getValidNoteArray(e,r).forEach(e=>{this.send([(l.MIDI_CHANNEL_VOICE_MESSAGES.noteon<<4)+(this.number-1),e.number,e.rawAttack],{time:n.convertToTimestamp(t.time)})}),this}sendChannelMode(e,t,a={}){if("string"==typeof e&&(e=l.MIDI_CHANNEL_MODE_MESSAGES[e]),l.validation){if(void 0===e)throw new TypeError("Invalid channel mode message name or number.");if(isNaN(e)||!(e>=120&&e<=127))throw new TypeError("Invalid channel mode message number.");if(isNaN(parseInt(t))||t<0||t>127)throw new RangeError("Value must be an integer between 0 and 127.")}return this.send([(l.MIDI_CHANNEL_VOICE_MESSAGES.channelmode<<4)+(this.number-1),e,t],{time:n.convertToTimestamp(a.time)}),this}setOmniMode(e,t={}){return void 0===e||e?this.sendChannelMode("omnimodeon",0,t):this.sendChannelMode("omnimodeoff",0,t),this}setChannelAftertouch(e,t={}){if(l.validation){if(isNaN(parseFloat(e)))throw new RangeError("Invalid channel aftertouch value.");if(t.rawValue){if(!(e>=0&&e<=127&&Number.isInteger(e)))throw new RangeError("Channel aftertouch raw value must be an integer between 0 and 127.")}else if(!(e>=0&&e<=1))throw new RangeError("Channel aftertouch value must be a float between 0 and 1.")}return this.send([(l.MIDI_CHANNEL_VOICE_MESSAGES.channelaftertouch<<4)+(this.number-1),Math.round(127*e)],{time:n.convertToTimestamp(t.time)}),this}setMasterTuning(e,t={}){if(e=parseFloat(e)||0,l.validation&&!(e>-65&&e<64))throw new RangeError("The value must be a decimal number larger than -65 and smaller than 64.");let n=Math.floor(e)+64,a=e-Math.floor(e);a=Math.round((a+1)/2*16383);let r=a>>7&127,s=127&a;return this.setRegisteredParameter("channelcoarsetuning",n,t),this.setRegisteredParameter("channelfinetuning",[r,s],t),this}setModulationRange(e,t,n={}){if(l.validation){if(!Number.isInteger(e)||!(e>=0&&e<=127))throw new RangeError("The semitones value must be an integer between 0 and 127.");if(!(null==t||Number.isInteger(t)&&t>=0&&t<=127))throw new RangeError("If specified, the cents value must be an integer between 0 and 127.")}return t>=0&&t<=127||(t=0),this.setRegisteredParameter("modulationrange",[e,t],n),this}setNonRegisteredParameter(e,t,n={}){if(t=[].concat(t),l.validation){if(!Array.isArray(e)||!Number.isInteger(e[0])||!Number.isInteger(e[1]))throw new TypeError("The specified NRPN is invalid.");if(!(e[0]>=0&&e[0]<=127))throw new RangeError("The first byte of the NRPN must be between 0 and 127.");if(!(e[1]>=0&&e[1]<=127))throw new RangeError("The second byte of the NRPN must be between 0 and 127.");t.forEach(e=>{if(!(e>=0&&e<=127))throw new RangeError("The data bytes of the NRPN must be between 0 and 127.")})}return this._selectNonRegisteredParameter(e,n),this._setCurrentParameter(t,n),this._deselectNonRegisteredParameter(n),this}setPitchBend(e,t={}){if(l.validation)if(t.rawValue&&Array.isArray(e)){if(!(e[0]>=0&&e[0]<=127))throw new RangeError("The pitch bend MSB must be an integer between 0 and 127.");if(!(e[1]>=0&&e[1]<=127))throw new RangeError("The pitch bend LSB must be an integer between 0 and 127.")}else if(t.rawValue&&!Array.isArray(e)){if(!(e>=0&&e<=127))throw new RangeError("The pitch bend MSB must be an integer between 0 and 127.")}else{if(isNaN(e)||null===e)throw new RangeError("Invalid pitch bend value.");if(!(e>=-1&&e<=1))throw new RangeError("The pitch bend MSB must be an integer between 0 and 127.")}let a=0,r=0;if(t.rawValue&&Array.isArray(e))a=e[0],r=e[1];else if(t.rawValue&&!Array.isArray(e))a=e;else{let t=Math.round((e+1)/2*16383);a=t>>7&127,r=127&t}return this.send([(l.MIDI_CHANNEL_VOICE_MESSAGES.pitchbend<<4)+(this.number-1),r,a],{time:n.convertToTimestamp(t.time)}),this}setPitchBendRange(e,t,n={}){if(l.validation){if(!Number.isInteger(e)||!(e>=0&&e<=127))throw new RangeError("The semitones value must be an integer between 0 and 127.");if(!Number.isInteger(t)||!(t>=0&&t<=127))throw new RangeError("The cents value must be an integer between 0 and 127.")}return this.setRegisteredParameter("pitchbendrange",[e,t],n),this}setProgram(e,t={}){if(e=parseInt(e)||1,l.validation&&!(e>=1&&e<=128))throw new RangeError("The program number must be between 1 and 128.");return this.send([(l.MIDI_CHANNEL_VOICE_MESSAGES.programchange<<4)+(this.number-1),e-1],{time:n.convertToTimestamp(t.time)}),this}setRegisteredParameter(e,t,n={}){if(Array.isArray(e)||(e=l.MIDI_REGISTERED_PARAMETER[e]),l.validation){if(!Number.isInteger(e[0])||!Number.isInteger(e[1]))throw new TypeError("The specified NRPN is invalid.");if(!(e[0]>=0&&e[0]<=127))throw new RangeError("The first byte of the RPN must be between 0 and 127.");if(!(e[1]>=0&&e[1]<=127))throw new RangeError("The second byte of the RPN must be between 0 and 127.");[].concat(t).forEach(e=>{if(!(e>=0&&e<=127))throw new RangeError("The data bytes of the RPN must be between 0 and 127.")})}return this._selectRegisteredParameter(e,n),this._setCurrentParameter(t,n),this._deselectRegisteredParameter(n),this}setTuningBank(e,t={}){if(l.validation&&(!Number.isInteger(e)||!(e>=1&&e<=128)))throw new RangeError("The tuning bank number must be between 1 and 128.");return this.setRegisteredParameter("tuningbank",e-1,t),this}setTuningProgram(e,t={}){if(l.validation&&(!Number.isInteger(e)||!(e>=1&&e<=128)))throw new RangeError("The tuning program number must be between 1 and 128.");return this.setRegisteredParameter("tuningprogram",e-1,t),this}setLocalControl(e,t={}){return e?this.sendChannelMode("localcontrol",127,t):this.sendChannelMode("localcontrol",0,t)}turnNotesOff(e={}){return this.sendChannelMode("allnotesoff",0,e)}turnSoundOff(e={}){return this.sendChannelMode("allsoundoff",0,e)}resetAllControllers(e={}){return this.sendChannelMode("resetallcontrollers",0,e)}setPolyphonicMode(e,t={}){return"mono"===e?this.sendChannelMode("monomodeon",0,t):this.sendChannelMode("polymodeon",0,t)}}class o extends e{constructor(e){if(super(),l.validation&&(!e||"output"!==e.type))throw new TypeError("The supplied MIDIOutput is invalid.");this._midiOutput=e,this.channels=[];for(let e=1;e<=16;e++)this.channels[e]=new i(this,e);this._midiOutput.onstatechange=this._onStateChange.bind(this)}async destroy(){this.removeListener(),this.channels.forEach(e=>e.destroy()),this.channels=[],this._midiOutput.onstatechange=null,await this.close(),this._midiOutput=null}_onStateChange(e){let t={timestamp:l.time};"open"===e.port.connection?(t.type="opened",t.target=this,this.emit("opened",t)):"closed"===e.port.connection&&"connected"===e.port.state?(t.type="closed",t.target=this,this.emit("closed",t)):"closed"===e.port.connection&&"disconnected"===e.port.state?(t.type="disconnected",t.target={connection:e.port.connection,id:e.port.id,manufacturer:e.port.manufacturer,name:e.port.name,state:e.port.state,type:e.port.type},this.emit("disconnected",t)):"pending"===e.port.connection&&"disconnected"===e.port.state||console.warn("This statechange event was not caught:",e.port.connection,e.port.state)}async open(){try{return await this._midiOutput.open(),Promise.resolve(this)}catch(e){return Promise.reject(e)}}async close(){this._midiOutput?await this._midiOutput.close():await Promise.resolve()}send(e,t={time:0},a){if(l.validation){if(Array.isArray(e)||e instanceof Uint8Array||(e=[e],Array.isArray(t)&&(e=e.concat(t)),t=a?{time:a}:{time:0}),!(parseInt(e[0])>=128&&parseInt(e[0])<=255))throw new RangeError("The first byte (status) must be an integer between 128 and 255.");e.slice(1).forEach(e=>{if(!((e=parseInt(e))>=0&&e<=255))throw new RangeError("Data bytes must be integers between 0 and 255.")}),t||(t={time:0})}return this._midiOutput.send(e,n.convertToTimestamp(t.time)),this}sendSysex(e,t,n={}){return t=(e=[].concat(e)).concat(t,l.MIDI_SYSTEM_MESSAGES.sysexend),this.send([l.MIDI_SYSTEM_MESSAGES.sysex].concat(t),{time:n.time}),this}clear(){return this._midiOutput.clear?this._midiOutput.clear():l.validation&&console.warn("The 'clear()' method has not yet been implemented in your environment."),this}sendTimecodeQuarterFrame(e,t={}){if(l.validation&&(e=parseInt(e),isNaN(e)||!(e>=0&&e<=127)))throw new RangeError("The value must be an integer between 0 and 127.");return this.send([l.MIDI_SYSTEM_MESSAGES.timecode,e],{time:t.time}),this}setSongPosition(e,t={}){var n=(e=Math.floor(e)||0)>>7&127,a=127&e;return this.send([l.MIDI_SYSTEM_MESSAGES.songposition,n,a],{time:t.time}),this}sendSongPosition(e,t={}){return l.validation&&console.warn("The sendSongPosition() method has been deprecated. Use setSongPosition() instead."),this.setSongPosition(e,t)}setSong(e,t={}){if(l.validation&&(e=parseInt(e),isNaN(e)||!(e>=1&&e<=128)))throw new RangeError("The program value must be between 1 and 128");return this.send([l.MIDI_SYSTEM_MESSAGES.songselect,e],{time:t.time}),this}sendSongSelect(e,t={}){return l.validation&&console.warn("The sendSongSelect() method has been deprecated. Use setSong() instead."),this.setSong(e,t)}sendTuneRequest(e={}){return this.send([l.MIDI_SYSTEM_MESSAGES.tunerequest],{time:e.time}),this}sendClock(e={}){return this.send([l.MIDI_SYSTEM_MESSAGES.clock],{time:e.time}),this}sendStart(e={}){return this.send([l.MIDI_SYSTEM_MESSAGES.start],{time:e.time}),this}sendContinue(e={}){return this.send([l.MIDI_SYSTEM_MESSAGES.continue],{time:e.time}),this}sendStop(e={}){return this.send([l.MIDI_SYSTEM_MESSAGES.stop],{time:e.time}),this}sendActiveSensing(e={}){return this.send([l.MIDI_SYSTEM_MESSAGES.activesensing],{time:e.time}),this}sendReset(e={}){return this.send([l.MIDI_SYSTEM_MESSAGES.reset],{time:e.time}),this}sendTuningRequest(e={}){return l.validation&&console.warn("The sendTuningRequest() method has been deprecated. Use sendTuningRequest() instead."),this.sendTuneRequest(e)}setKeyAftertouch(e,t,a={},r={}){if(l.validation&&(Array.isArray(t)||Number.isInteger(t)||"all"===t)){let e=t;t=a,(a=r).channels=e}return null==a.channels&&(a.channels="all"),n.sanitizeChannels(a.channels).forEach(n=>{this.channels[n].setKeyAftertouch(e,t,a)}),this}sendKeyAftertouch(e,t,n,a={}){return l.validation&&console.warn("The sendKeyAftertouch() method has been deprecated. Use setKeyAftertouch() instead."),a.channels=t,this.setKeyAftertouch(e,n,a)}sendControlChange(e,t,a={},r={}){if(l.validation&&(Array.isArray(a)||Number.isInteger(a)||"all"===a)){let e=a;(a=r).channels=e}return null==a.channels&&(a.channels="all"),n.sanitizeChannels(a.channels).forEach(n=>{this.channels[n].sendControlChange(e,t,a)}),this}setPitchBendRange(e,t,a={},r={}){if(l.validation&&(Array.isArray(a)||Number.isInteger(a)||"all"===a)){let e=a;(a=r).channels=e}return null==a.channels&&(a.channels="all"),n.sanitizeChannels(a.channels).forEach(n=>{this.channels[n].setPitchBendRange(e,t,a)}),this}setRegisteredParameter(e,t,a={},r={}){if(l.validation&&(Array.isArray(a)||Number.isInteger(a)||"all"===a)){let e=a;(a=r).channels=e}return null==a.channels&&(a.channels="all"),n.sanitizeChannels(a.channels).forEach(n=>{this.channels[n].setRegisteredParameter(e,t,a)}),this}setChannelAftertouch(e,t={},a={}){if(l.validation&&(Array.isArray(t)||Number.isInteger(t)||"all"===t)){let e=t;(t=a).channels=e}return null==t.channels&&(t.channels="all"),n.sanitizeChannels(t.channels).forEach(n=>{this.channels[n].setChannelAftertouch(e,t)}),this}sendChannelAftertouch(e,t,n={}){return l.validation&&console.warn("The sendChannelAftertouch() method has been deprecated. Use setChannelAftertouch()."),n.channels=t,this.setChannelAftertouch(e,n)}setPitchBend(e,t={},a={}){if(l.validation&&(Array.isArray(t)||Number.isInteger(t)||"all"===t)){let e=t;(t=a).channels=e}return null==t.channels&&(t.channels="all"),n.sanitizeChannels(t.channels).forEach(n=>{this.channels[n].setPitchBend(e,t)}),this}sendPitchBend(e,t,n={}){return l.validation&&console.warn("The sendPitchBend() method has been deprecated. Use setPitchBend() instead."),n.channels=t,this.setPitchBend(e,n)}setProgram(e,t={},a={}){if(l.validation&&(Array.isArray(t)||Number.isInteger(t)||"all"===t)){let e=t;(t=a).channels=e}return null==t.channels&&(t.channels="all"),n.sanitizeChannels(t.channels).forEach(n=>{this.channels[n].setProgram(e,t)}),this}sendProgramChange(e,t,n={}){return l.validation&&console.warn("The sendProgramChange() method has been deprecated. Use setProgram() instead."),n.channels=t,this.setProgram(e,n)}setModulationRange(e,t,a={},r={}){if(l.validation&&(Array.isArray(a)||Number.isInteger(a)||"all"===a)){let e=a;(a=r).channels=e}return null==a.channels&&(a.channels="all"),n.sanitizeChannels(a.channels).forEach(n=>{this.channels[n].setModulationRange(e,t,a)}),this}setMasterTuning(e,t={},a={}){if(l.validation&&(Array.isArray(t)||Number.isInteger(t)||"all"===t)){let e=t;(t=a).channels=e}return null==t.channels&&(t.channels="all"),n.sanitizeChannels(t.channels).forEach(n=>{this.channels[n].setMasterTuning(e,t)}),this}setTuningProgram(e,t={},a={}){if(l.validation&&(Array.isArray(t)||Number.isInteger(t)||"all"===t)){let e=t;(t=a).channels=e}return null==t.channels&&(t.channels="all"),n.sanitizeChannels(t.channels).forEach(n=>{this.channels[n].setTuningProgram(e,t)}),this}setTuningBank(e,t={},n={}){if(l.validation&&(Array.isArray(t)||Number.isInteger(t)||"all"===t)){let e=t;(t=n).channels=e}return null==t.channels&&(t.channels="all"),l.sanitizeChannels(t.channels).forEach(n=>{this.channels[n].setTuningBank(e,t)}),this}sendChannelMode(e,t,a={},r={}){if(l.validation&&(Array.isArray(a)||Number.isInteger(a)||"all"===a)){let e=a;(a=r).channels=e}return null==a.channels&&(a.channels="all"),n.sanitizeChannels(a.channels).forEach(n=>{this.channels[n].sendChannelMode(e,t,a)}),this}turnSoundOff(e={},t={}){if(l.validation&&(Array.isArray(e)||Number.isInteger(e)||"all"===e)){let n=e;(e=t).channels=n}return null==e.channels&&(e.channels="all"),n.sanitizeChannels(e.channels).forEach(t=>{this.channels[t].turnSoundOff(e)}),this}turnNotesOff(e={},t={}){if(l.validation&&(Array.isArray(e)||Number.isInteger(e)||"all"===e)){let n=e;(e=t).channels=n}return null==e.channels&&(e.channels="all"),n.sanitizeChannels(e.channels).forEach(t=>{this.channels[t].turnNotesOff(e)}),this}resetAllControllers(e={},t={}){if(l.validation&&(Array.isArray(e)||Number.isInteger(e)||"all"===e)){let n=e;(e=t).channels=n}return null==e.channels&&(e.channels="all"),n.sanitizeChannels(e.channels).forEach(t=>{this.channels[t].resetAllControllers(e)}),this}setPolyphonicMode(e,t={},a={}){if(l.validation&&(Array.isArray(t)||Number.isInteger(t)||"all"===t)){let e=t;(t=a).channels=e}return null==t.channels&&(t.channels="all"),n.sanitizeChannels(t.channels).forEach(n=>{this.channels[n].setPolyphonicMode(e,t)}),this}setLocalControl(e,t={},a={}){if(l.validation&&(Array.isArray(t)||Number.isInteger(t)||"all"===t)){let e=t;(t=a).channels=e}return null==t.channels&&(t.channels="all"),n.sanitizeChannels(t.channels).forEach(n=>{this.channels[n].setLocalControl(e,t)}),this}setOmniMode(e,t={},a={}){if(l.validation&&(Array.isArray(t)||Number.isInteger(t)||"all"===t)){let e=t;(t=a).channels=e}return null==t.channels&&(t.channels="all"),n.sanitizeChannels(t.channels).forEach(n=>{this.channels[n].setOmniMode(e,t)}),this}setNonRegisteredParameter(e,t,a={},r={}){if(l.validation&&(Array.isArray(a)||Number.isInteger(a)||"all"===a)){let e=a;(a=r).channels=e}return null==a.channels&&(a.channels="all"),n.sanitizeChannels(a.channels).forEach(n=>{this.channels[n].setNonRegisteredParameter(e,t,a)}),this}incrementRegisteredParameter(e,t={},a={}){if(l.validation&&(Array.isArray(t)||Number.isInteger(t)||"all"===t)){let e=t;(t=a).channels=e}return null==t.channels&&(t.channels="all"),n.sanitizeChannels(t.channels).forEach(n=>{this.channels[n].incrementRegisteredParameter(e,t)}),this}decrementRegisteredParameter(e,t={},a={}){if(l.validation&&(Array.isArray(t)||Number.isInteger(t)||"all"===t)){let e=t;(t=a).channels=e}return null==t.channels&&(t.channels="all"),n.sanitizeChannels(t.channels).forEach(n=>{this.channels[n].decrementRegisteredParameter(e,t)}),this}sendNoteOff(e,t={},a={}){if(l.validation&&(Array.isArray(t)||Number.isInteger(t)||"all"===t)){let e=t;(t=a).channels=e}return null==t.channels&&(t.channels="all"),n.sanitizeChannels(t.channels).forEach(n=>{this.channels[n].sendNoteOff(e,t)}),this}stopNote(e,t){return this.sendNoteOff(e,t)}playNote(e,t={},a={}){if(l.validation&&(t.rawVelocity&&console.warn("The 'rawVelocity' option is deprecated. Use 'rawAttack' instead."),t.velocity&&console.warn("The 'velocity' option is deprecated. Use 'velocity' instead."),Array.isArray(t)||Number.isInteger(t)||"all"===t)){let e=t;(t=a).channels=e}return null==t.channels&&(t.channels="all"),n.sanitizeChannels(t.channels).forEach(n=>{this.channels[n].playNote(e,t)}),this}sendNoteOn(e,t={},n={}){if(l.validation&&(Array.isArray(t)||Number.isInteger(t)||"all"===t)){let e=t;(t=n).channels=e}return null==t.channels&&(t.channels="all"),l.sanitizeChannels(t.channels).forEach(n=>{this.channels[n].sendNoteOn(e,t)}),this}get name(){return this._midiOutput.name}get id(){return this._midiOutput.id}get connection(){return this._midiOutput.connection}get manufacturer(){return this._midiOutput.manufacturer}get state(){return this._midiOutput.state}get type(){return this._midiOutput.type}}const l=new class extends e{constructor(){super(),this.defaults={note:{attackVelocity:.5,releaseVelocity:.5,duration:1/0}},this.interface=null,this.validation=!0,this._inputs=[],this._outputs=[],this._stateChangeQueue=[],this._octaveOffset=0}async enable(e={},t=!1){if(this.validation=!1!==e.validation,this.validation&&("function"==typeof e&&(e={callback:e,sysex:t}),t&&(e.sysex=!0)),this.enabled)return"function"==typeof e.callback&&e.callback(),Promise.resolve();const n={timestamp:this.time,target:this,type:"error",error:void 0},a={timestamp:this.time,target:this,type:"midiaccessgranted"},r={timestamp:this.time,target:this,type:"enabled"};try{this.interface=await navigator.requestMIDIAccess({sysex:e.sysex,software:e.software})}catch(t){return n.error=t,this.emit("error",n),"function"==typeof e.callback&&e.callback(t),Promise.reject(t)}let s;this.emit("midiaccessgranted",a),this.interface.onstatechange=this._onInterfaceStateChange.bind(this);try{s=await this._updateInputsAndOutputs()}catch(t){return n.error=t,this.emit("error",n),"function"==typeof e.callback&&e.callback(t),Promise.reject(t)}return this.emit("enabled",r),"function"==typeof e.callback&&e.callback(),Promise.resolve({inputs:s[0],outputs:s[1]})}async disable(){return this._destroyInputsAndOutputs().then(()=>{"function"==typeof navigator.close&&navigator.close(),this.interface&&(this.interface.onstatechange=void 0),this.interface=null;let e={timestamp:this.time,target:this,type:"disabled"};this.emit("disabled",e),this.removeListener()})}getInputById(e){if(this.validation){if(!this.enabled)throw new Error("WebMidi is not enabled.");if(!e)return!1}for(let t=0;t<this.inputs.length;t++)if(this.inputs[t].id===e.toString())return this.inputs[t];return!1}getInputByName(e){if(this.validation){if(!this.enabled)throw new Error("WebMidi is not enabled.");if(!e)return!1;e=e.toString()}for(let t=0;t<this.inputs.length;t++)if(~this.inputs[t].name.indexOf(e))return this.inputs[t];return!1}getOutputByName(e){if(this.validation){if(!this.enabled)throw new Error("WebMidi is not enabled.");if(!e)return!1;e=e.toString()}for(let t=0;t<this.outputs.length;t++)if(~this.outputs[t].name.indexOf(e))return this.outputs[t];return!1}getOutputById(e){if(this.validation){if(!this.enabled)throw new Error("WebMidi is not enabled.");if(!e)return!1}for(let t=0;t<this.outputs.length;t++)if(this.outputs[t].id===e.toString())return this.outputs[t];return!1}noteNameToNumber(e){return this.validation&&console.warn("The getNoteNumberByName() method has been moved to the Utilities class in version 3."),n.getNoteNumberByName(e,{octaveOffset:this.octaveOffset})}getOctave(e){return this.validation&&(e=parseInt(e)),!isNaN(e)&&e>=0&&e<=127&&Math.floor(e/12-1)+this.octaveOffset}sanitizeChannels(e){return this.validation&&console.warn("The sanitizeChannels() method has been moved to the utilities class."),n.sanitizeChannels(e)}toMIDIChannels(e){return this.validation&&console.warn("The toMIDIChannels() method has been deprecated. Use sanitizeChannels() instead."),n.sanitizeChannels(e)}guessNoteNumber(e){return this.validation&&console.warn("The guessNoteNumber() method has been moved to the Utilities class."),n.guessNoteNumber(e,{octaveOffset:this.octaveOffset})}getValidNoteArray(e,t={}){return this.validation&&console.warn("The getValidNoteArray() method has been moved to the Utilities class."),n.getValidNoteArray(e,t)}convertToTimestamp(e){return this.validation&&console.warn("The convertToTimestamp() method has been moved to the utilities class."),n.convertToTimestamp(e)}async _destroyInputsAndOutputs(){let e=[];return this.inputs.forEach(t=>e.push(t.destroy())),this.outputs.forEach(t=>e.push(t.destroy())),Promise.all(e).then(()=>{this._inputs=[],this._outputs=[]})}_onInterfaceStateChange(e){this._updateInputsAndOutputs();let t={timestamp:e.timeStamp,type:e.port.state};this.interface&&"connected"===e.port.state?"output"===e.port.type?(t.port=this.getOutputById(e.port.id),t.target=t.port):"input"===e.port.type&&(t.port=this.getInputById(e.port.id),t.target=t.port):(t.port={connection:"closed",id:e.port.id,manufacturer:e.port.manufacturer,name:e.port.name,state:e.port.state,type:e.port.type},t.target=t.port),this.emit(e.port.state,t)}async _updateInputsAndOutputs(){return Promise.all([this._updateInputs(),this._updateOutputs()])}async _updateInputs(){let e=[];for(let e=0;e<this._inputs.length;e++){let t=!0,n=this.interface.inputs.values();for(let a=n.next();a&&!a.done;a=n.next())if(this._inputs[e]._midiInput===a.value){t=!1;break}t&&this._inputs.splice(e,1)}return this.interface&&this.interface.inputs.forEach(t=>{let n=!0;for(let e=0;e<this._inputs.length;e++)this._inputs[e]._midiInput===t&&(n=!1);if(n){let n=new s(t);this._inputs.push(n),e.push(n.open())}}),Promise.all(e)}async _updateOutputs(){let e=[];for(let e=0;e<this._outputs.length;e++){let t=!0,n=this.interface.outputs.values();for(let a=n.next();a&&!a.done;a=n.next())if(this._outputs[e]._midiOutput===a.value){t=!1;break}t&&(this._outputs[e].close(),this._outputs.splice(e,1))}return this.interface&&this.interface.outputs.forEach(t=>{let n=!0;for(let e=0;e<this._outputs.length;e++)this._outputs[e]._midiOutput===t&&(n=!1);if(n){let n=new o(t);this._outputs.push(n),e.push(n.open())}}),Promise.all(e)}get enabled(){return null!==this.interface}get inputs(){return this._inputs}get isNode(){return"[object process]"===Object.prototype.toString.call("undefined"!=typeof process?process:0)}get isBrowser(){return"undefined"!=typeof window&&void 0!==window.document}get octaveOffset(){return this._octaveOffset}set octaveOffset(e){if(this.validation&&(e=parseInt(e),isNaN(e)))throw new TypeError("The 'octaveOffset' property must be an integer.");this._octaveOffset=e}get outputs(){return this._outputs}get supported(){return"undefined"!=typeof navigator&&navigator.requestMIDIAccess}get sysexEnabled(){return!(!this.interface||!this.interface.sysexEnabled)}get time(){return performance.now()}get MIDI_CHANNEL_VOICE_MESSAGES(){return{noteoff:8,noteon:9,keyaftertouch:10,controlchange:11,channelmode:11,nrpn:11,programchange:12,channelaftertouch:13,pitchbend:14}}get MIDI_CHANNEL_MESSAGES(){return this.validation&&console.warn("MIDI_CHANNEL_MESSAGES has been deprecated. Use MIDI_CHANNEL_VOICE_MESSAGES instead."),this.MIDI_CHANNEL_VOICE_MESSAGES}get MIDI_CHANNEL_MODE_MESSAGES(){return{allsoundoff:120,resetallcontrollers:121,localcontrol:122,allnotesoff:123,omnimodeoff:124,omnimodeon:125,monomodeon:126,polymodeon:127}}get MIDI_CONTROL_CHANGE_MESSAGES(){return{bankselectcoarse:0,modulationwheelcoarse:1,breathcontrollercoarse:2,footcontrollercoarse:4,portamentotimecoarse:5,dataentrycoarse:6,volumecoarse:7,balancecoarse:8,pancoarse:10,expressioncoarse:11,effectcontrol1coarse:12,effectcontrol2coarse:13,generalpurposeslider1:16,generalpurposeslider2:17,generalpurposeslider3:18,generalpurposeslider4:19,bankselectfine:32,modulationwheelfine:33,breathcontrollerfine:34,footcontrollerfine:36,portamentotimefine:37,dataentryfine:38,volumefine:39,balancefine:40,panfine:42,expressionfine:43,effectcontrol1fine:44,effectcontrol2fine:45,holdpedal:64,portamento:65,sustenutopedal:66,softpedal:67,legatopedal:68,hold2pedal:69,soundvariation:70,resonance:71,soundreleasetime:72,soundattacktime:73,brightness:74,soundcontrol6:75,soundcontrol7:76,soundcontrol8:77,soundcontrol9:78,soundcontrol10:79,generalpurposebutton1:80,generalpurposebutton2:81,generalpurposebutton3:82,generalpurposebutton4:83,reverblevel:91,tremololevel:92,choruslevel:93,celestelevel:94,phaserlevel:95,databuttonincrement:96,databuttondecrement:97,nonregisteredparametercoarse:98,nonregisteredparameterfine:99,registeredparametercoarse:100,registeredparameterfine:101}}get MIDI_INTERFACE_EVENTS(){return["connected","disconnected"]}get MIDI_NRPN_MESSAGES(){return{entrymsb:6,entrylsb:38,increment:96,decrement:97,paramlsb:98,parammsb:99,nullactiveparameter:127}}get MIDI_REGISTERED_PARAMETER(){return{pitchbendrange:[0,0],channelfinetuning:[0,1],channelcoarsetuning:[0,2],tuningprogram:[0,3],tuningbank:[0,4],modulationrange:[0,5],azimuthangle:[61,0],elevationangle:[61,1],gain:[61,2],distanceratio:[61,3],maximumdistance:[61,4],maximumdistancegain:[61,5],referencedistanceratio:[61,6],panspreadangle:[61,7],rollangle:[61,8]}}get MIDI_SYSTEM_MESSAGES(){return{sysex:240,timecode:241,songposition:242,songselect:243,tunerequest:246,tuningrequest:246,sysexend:247,clock:248,start:250,continue:251,stop:252,activesensing:254,reset:255,midimessage:0,unknownsystemmessage:-1}}get NOTES(){return["C","C#","D","D#","E","F","F#","G","G#","A","A#","B"]}};l.constructor=null;export{a as Note,n as Utilities,l as WebMidi};
//# sourceMappingURL=webmidi.esm.min.js.map
